package com.shkj.common.utils;

import com.shkj.common.constant.HttpStatus;
import com.shkj.common.core.domain.entity.SysUser;
import com.shkj.common.core.domain.model.LoginUser;
import com.shkj.common.exception.ServiceException;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import java.util.List;

/**
 * 安全服务工具类
 *
 * @author lch
 */
public class SecurityUtils {

    /**
     * erp仓库id 固定
     */
    public static Long erpBranchId = 3L;

    /**
     * 用户ID
     **/
    public static Long getUserId() {
        try {
            return getLoginUser().getUserId();
        } catch (Exception e) {
            throw new ServiceException("获取用户ID异常", HttpStatus.UNAUTHORIZED);
        }
    }

    /**
     * 仓库ID
     **/
    public static Long getCurrentBranchId() {
        try {
            Long branchId = getLoginUser().getCurrentBranchId();
            return branchId == null ? 0L : branchId;
        } catch (Exception e) {
            throw new ServiceException("获取仓库ID异常", HttpStatus.UNAUTHORIZED);
        }
    }

    /**
     * 仓库ID
     **/
    public static List<Long> getBranchIds() {
        try {
            return getLoginUser().getBranchIds();
        } catch (Exception e) {
            throw new ServiceException("获取仓库ID集合异常", HttpStatus.UNAUTHORIZED);
        }
    }

    /**
     * 获取部门ID
     **/
    public static Long getDeptId() {
        try {
            return getLoginUser().getDeptId();
        } catch (Exception e) {
            throw new ServiceException("获取部门ID异常", HttpStatus.UNAUTHORIZED);
        }
    }

    /**
     * 获取用户账户
     **/
    public static String getUsername() {
        try {
            return getLoginUser().getUsername();
        } catch (Exception e) {
            String uri = ((ServletRequestAttributes) RequestContextHolder.getRequestAttributes()).getRequest().getRequestURI();
            if (uri.contains("/wms/third/") || uri.contains("UploadData") || uri.contains("containerArrived")) {
                return "system";
            }
            throw new ServiceException("获取用户账户异常", HttpStatus.UNAUTHORIZED);
        }
    }

    /**
     * 获取用户
     **/
    public static LoginUser getLoginUser() {
        try {
            return (LoginUser) getAuthentication().getPrincipal();
        } catch (Exception e) {
            String uri = ((ServletRequestAttributes) RequestContextHolder.getRequestAttributes()).getRequest().getRequestURI();
            if (uri.contains("/wms/third/") || uri.contains("UploadData") || uri.contains("containerArrived") || uri.contains("/wms/")|| uri.contains("/wcs/") || uri.contains("PlcEventTask")) {
                return user;
            }
            throw new ServiceException("获取用户信息异常", HttpStatus.UNAUTHORIZED);
        }
    }

    /**
     * erp固定仓库
     */
    public static LoginUser user = new LoginUser();

    static {
        user.setUserId(1L);
        user.setCurrentBranchId(erpBranchId);
        SysUser sysUser = new SysUser();
        sysUser.setUserId(1L);
        sysUser.setUserName("admin");
        user.setUser(sysUser);
    }

    /**
     * 获取Authentication
     */
    public static Authentication getAuthentication() {
        return SecurityContextHolder.getContext().getAuthentication();
    }

    /**
     * 生成BCryptPasswordEncoder密码
     *
     * @param password 密码
     * @return 加密字符串
     */
    public static String encryptPassword(String password) {
        BCryptPasswordEncoder passwordEncoder = new BCryptPasswordEncoder();
        return passwordEncoder.encode(password);
    }

    /**
     * 判断密码是否相同
     *
     * @param rawPassword     真实密码
     * @param encodedPassword 加密后字符
     * @return 结果
     */
    public static boolean matchesPassword(String rawPassword, String encodedPassword) {
        BCryptPasswordEncoder passwordEncoder = new BCryptPasswordEncoder();
        return passwordEncoder.matches(rawPassword, encodedPassword);
    }

    /**
     * 是否为管理员
     *
     * @param userId 用户ID
     * @return 结果
     */
    public static boolean isAdmin(Long userId) {
        return userId != null && 1L == userId;
    }
}
